/*
 * Copyright (c) 2022, Technische Universität Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors:
 *    Iron Prando da Silva
 */

#include "configurationBase.h"

const uint ConfigurationBase::getClk() const {
    if (!mDeviceDeps) 
        throw std::invalid_argument("Invalid DRAMTimeDependenciesBase object in 'ConfigurationBase::getClk'.");

    return mDeviceDeps->getClk();
}

DependencyMap ConfigurationBase::getDependencies(std::vector<QString>& commands) const {
    if (!mDeviceDeps) 
        throw std::invalid_argument("Invalid DRAMTimeDependenciesBase object in 'ConfigurationBase::getDependencies'.");

    return mDeviceDeps->getDependencies(commands);
}

PoolControllerMap ConfigurationBase::getPools() const {
    if (!mDeviceDeps) 
        throw std::invalid_argument("Invalid DRAMTimeDependenciesBase object in 'ConfigurationBase::getAWPools'.");

    return mDeviceDeps->getPools();
}

const QString ConfigurationBase::getDeviceName(const TraceDB& tdb) {
    return mGetMemspec(tdb)["memoryType"].toString();
}

const uint ConfigurationBase::mGetClk(const TraceDB& tdb) {
    QSqlDatabase db = tdb.getDatabase();
    QString query = "SELECT clk FROM GeneralInfo";
    QSqlQuery sqlQuery = db.exec(query);

    sqlQuery.next();
    uint clock = sqlQuery.value(0).toLongLong();
    sqlQuery.finish();

    return clock;
}

const QJsonObject ConfigurationBase::mGetMemspec(const TraceDB& tdb) {
    QSqlDatabase db = tdb.getDatabase();
    QString query = "SELECT Memspec FROM GeneralInfo";
    QSqlQuery sqlQuery = db.exec(query);

    sqlQuery.next();
    QString memSpecJson = sqlQuery.value(0).toString();
    sqlQuery.finish();

    QJsonDocument jsonDocument = QJsonDocument::fromJson(memSpecJson.toUtf8());

    return jsonDocument.object()["memspec"].toObject();
}
